=== debian/changelog ===
ckb-next (0.4.3+dfsg.1-0.1) unstable; urgency=medium

  [Marc Dequènes]
  * Non-maintainer upload.
  * NUR (Closes: #977506, #976366):
    + Add build dependency on qttools5-dev.

  [Antonio Russo]
  * Update Build-Deps for 0.4.3.
  * Refreshed patches.
  * Use SYSTEMD_UNIT_INSTALL_DIR instead of a custom cmake patch.

 -- Marc Dequènes (Duck) <Duck@DuckCorp.org>  Fri, 15 Jan 2021 16:31:29 +0900

ckb-next (0.4.2+dfsg.1-2) unstable; urgency=medium

  * Adding upstream patch for gcc10 compatibility (Closes: 957091)
  * Removing libappindicator bdep (Closes: 956765)
  * Bumping compat 13
  * Bumping Standards-Version 4.5.0
  * Bumping copyright year

 -- Stewart Ferguson <stew@ferg.aero>  Sun, 02 Aug 2020 12:40:44 +0200
