=== debian/control ===
Source: ckb-next
Section: electronics
Priority: optional
Maintainer: Stewart Ferguson <stew@ferg.aero>
Build-Depends: cmake (>= 3.5.1),
               debhelper-compat (= 13),
               libdbusmenu-qt5-dev,
               libpulse-dev,
               libqt5x11extras5-dev (>= 5.2.0),
               libquazip5-dev,
               libudev-dev,
               libxcb-ewmh-dev,
               libxcb-screensaver0-dev,
               libxcb1-dev,
               qtbase5-dev (>= 5.5.1),
               qttools5-dev,
               zlib1g-dev
Standards-Version: 4.5.0
Homepage: https://github.com/ckb-next/ckb-next
Vcs-Browser: https://salsa.debian.org/debian/ckb-next
Vcs-Git: https://salsa.debian.org/debian/ckb-next.git
Rules-Requires-Root: no

Package: ckb-next
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: driver for Corsair keyboards and mice
 ckb-next is an open-source driver for Corsair keyboards and mice.
 It aims to bring the features of Corsair's proprietary CUE
 software to the Linux and Mac operating systems.
